"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.convertFlowObjectTypeAnnotation = convertFlowObjectTypeAnnotation;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function flowTypeAnnotationToString(type) {
  switch (type.type) {
    case "NullableTypeAnnotation":
      return "?" + flowTypeAnnotationToString(type.typeAnnotation);
    case "BooleanTypeAnnotation":
      return "boolean";
    case "NumberTypeAnnotation":
      return "number";
    case "StringTypeAnnotation":
      return "string";
    default:
      return "any";
  }
}

// convert an ObjectTypeAnnotation to a js object

function convertFlowObjectTypeAnnotation(objectType) {
  var flowTypes = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  return objectType.properties.reduce(function (obj, property) {
    var key = property.key.name;
    var value = property.value;
    if (value.type === "ObjectTypeAnnotation") {
      return _extends({}, obj, _defineProperty({}, key, {
        type: "object",
        nullable: property.optional,
        properties: convertFlowObjectTypeAnnotation(value, flowTypes)
      }));
    }

    if (value.type === "GenericTypeAnnotation" && value.id && flowTypes[value.id.name]) {
      return _extends({}, obj, _defineProperty({}, key, {
        type: "object",
        nullable: property.optional,
        properties: convertFlowObjectTypeAnnotation(flowTypes[value.id.name], flowTypes)
      }));
    }

    return _extends({}, obj, _defineProperty({}, key, {
      type: flowTypeAnnotationToString(value),
      nullable: property.optional
    }));
  }, {});
}